# sails-hook-actions

[Sails JS](http://sailsjs.org) hook to load files from the `api/actions` folder and interpret them as machines compatible with [machine-as-action](https://github.com/treelinehq/machine-as-action).

This hook adds support for the `{action: 'some-action'}` route target syntax.  Traditional controller files (in `api/controllers`) and controller route target syntax are still supported.

### Installation

`npm install sails-hook-actions`

### Usage
*requires at least sails >= 0.12*

Create an `api/actions` folder, then add Javascript files (ending in `.js`) in that folder or in subfolders.  The files must be valid [node-machine](http://node-machine.org/) definitions, and may include the additional options described in the [machine actions](https://github.com/treelinehq/machine-as-action) docs (e.g. the `responseType` property for exits).

To point a route at an action, use the `{action: 'some-action-identity'}` syntax, for example:

```
'GET /hi': {action: 'say-hi'}
'POST /user/go': {action: 'useractions/some-user-action'}
```

where the value of `action` is the identity of an action (i.e. its filepath relative to `api/actions`, lowercased and without the `.js` extension)
