var _ = require('lodash');

var machineAsAction = require('machine-as-action');
var buildDictionary = require('sails-build-dictionary');

module.exports = function(sails, cb) {

  var self = this;
  sails.actions = {};

  // Load action defs out of the specified folder
  buildDictionary.optional({
    dirname: sails.config[this.configKey].actionsDir,
    filter: new RegExp('(.+)\\.(' + sails.config.moduleloader.sourceExt.join('|') + ')$'),
    flattenDirectories: true,
    keepDirectoryPath: true
  }, function(err, actionDefs) {

    // Loop through each action, attempting to load each one as a machine
    // using machine-as-action.
    _.each(actionDefs, function(actionDef, identity) {

      try {
        sails.actions[identity] = machineAsAction(actionDef);
      } catch (e) {
        sails.log.error('Failed to load action `' + identity +'` as a machine!');
        return cb(e);
      }

    });

    return cb();

  });

};
